#include <fstream>
//--//
#include <SDL/SDL.h>     
#include <SDL/SDL_Image.h>                                                       
//--//
using namespace std;
//--//
#include "Base_SDL.h"
#include "Base_Events.h"
#include "Base_Framelimit.h"
#include "Base_Surface.h"
//--//

////////////////////////////////////////////////////////////////////////////////
//Name:    Program Init
//Purpose: Program Specific Initializations
////////////////////////////////////////////////////////////////////////////////
void program_init()
{printf("DEBUG:  Attempting to Init SDL \n");
 sdl.init(SDL_INIT_VIDEO);
 printf("DEBUG:  SDL Initialized \n");
 fps.init();
}

////////////////////////////////////////////////////////////////////////////////
//Name:    Program Cleanup
//Purpose: Program Specific Cleanup
////////////////////////////////////////////////////////////////////////////////
void program_cleanup()
{SDL_Quit();
 printf("DEBUG:  Libraries Cleaned Up, Exiting Program \n");
}

////////////////////////////////////////////////////////////////////////////////
//Name:    FPS Update
//Purpose: Display the current FPS count for the program
////////////////////////////////////////////////////////////////////////////////
void fps_update()
{if(sdl.screen->flags & SDL_FULLSCREEN)
   {printf("FPS:%i/%i fps - %ims %ims %fms \n",WINDOW_TEXT,fps_data.fps,FPS_MAX, fps_data.frame_min, fps_data.frame_max, fps_data.frame_average);
   }
 else
   {char display_text[128];
    sprintf(display_text,"%s - %i/%i fps - %ims %ims %fms",WINDOW_TEXT,fps_data.fps,FPS_MAX, fps_data.frame_min, fps_data.frame_max, fps_data.frame_average);
    SDL_WM_SetCaption(display_text,NULL);
   }     
}

////////////////////////////////////////////////////////////////////////////////
//Name:    Main
//Purpose: Main Loopage
////////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{program_init();
 //--//
 SDL_Surface *bob;
 while(!sdl.done)
   {event_update();
    surface.draw(bob,sdl.screen,0,0);
    SDL_Flip(sdl.screen);
    if(fps.limit()==true)
      {fps_update();
      }
   }
 //--//
 program_cleanup();
}
